/* Example.c
 * Michael McTernan, mm7323@bris.ac.uk
 * 12/4/00
 */

#include <stdio.h>
#include "HashFile.h"

typedef struct tuple {
  char Key[10];
  char Data[100];
} tuple_t;


int main() {
  hashfile_t HF;
  tuple_t    Tuple;
  int        t;

  /* Create a new file */
  HF=HASH_New("Example.hf",HASH_CalculateNiceSize(20,0.8),sizeof(tuple_t));

  /* Add some data */
  for(t=0;t<20;t++) {
    sprintf(Tuple.Key,"Key%d",t);
    sprintf(Tuple.Data,"Data%d",t);
    
    HASH_Add(HF,&Tuple,strlen(Tuple.Key));

  }

  /* NOTE: I close and re-open the hash file only
   *       as an example.  In practice, you could
   *       Get from the hash table as or after you
   *       created it, without re-opening.
   */

  /* Close it */
  HASH_Close(HF);


  /* Open it as an exisiting hash file */
  HF=HASH_Open("Example.hf",1,sizeof(tuple_t));

  /* Get some data */
  for(t=0;t<20;t++) {
    char Buffer[10];

    sprintf(Buffer,"Key%d",t);

    if(!HASH_Get(HF,Buffer,strlen(Buffer),&Tuple))
      printf("Not found!\n");   /* Should never happen in this example */
    else
      printf("%s\t%s\n",Tuple.Key,Tuple.Data);

  }

  /* Close it */
  HASH_Close(HF);


  return 0;
}
